package com.landray.kmss.sys.attachment.service.spring;

import com.landray.kmss.sys.restservice.server.model.SysRestserviceServerMain;
import com.landray.kmss.util.SignUtil;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.sys.restservice.server.model.SysRestserviceServerPolicy;
import com.landray.kmss.util.ArrayUtil;
import com.landray.kmss.sys.restservice.server.service.ISysRestserviceServerMainService;
import java.util.List;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import javax.servlet.http.HttpServletRequest;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import com.landray.kmss.sys.attachment.service.ISysAttMainFoxitService;

public class SysAttMainFoxitServiceImp implements ISysAttMainFoxitService
{
    protected ISysAttMainCoreInnerService sysAttMainService;
    
    protected ISysAttMainCoreInnerService getSysAttMainCoreInnerService() {
        if (this.sysAttMainService == null) {
            this.sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
        }
        return this.sysAttMainService;
    }
    
    public void createRequestMateData(final HttpServletRequest request, SysAttMain sysAttMain, final Boolean searchSysAttMain) throws Exception {
        if (searchSysAttMain) {
            final List<SysAttMain> sysAttMains = this.getSysAttMainCoreInnerService().findAttListByModel(sysAttMain.getFdModelName(), sysAttMain.getFdModelId());
            if (!sysAttMains.isEmpty()) {
                sysAttMain = sysAttMains.get(0);
            }
        }
        final long expires = System.currentTimeMillis() + 180000L;
        final String sign = this.getRestSign(sysAttMain.getFdId(), expires);
        final SysAttMainFoxitBuilder sysAttMainFoxitBuilder = new SysAttMainFoxitBuilder();
        sysAttMainFoxitBuilder.creatFoxitAuthorization(request).createSysAuthorization(request, sysAttMain).createSysFileInfo(request, sysAttMain, sign, expires).createWaterInfo(request).createOthersInfo(request);
    }
    
    private String getRestSign(final String attMainId, final long expires) throws Exception {
        final String signStr = String.valueOf(expires) + ":" + attMainId;
        final ISysRestserviceServerMainService sysRestMainService = (ISysRestserviceServerMainService)SpringBeanUtil.getBean("sysRestserviceServerMainService");
        final SysRestserviceServerMain sysRestserviceServerMain = sysRestMainService.findByServiceBean("sysAttachmentRestService");
        final List<SysRestserviceServerPolicy> webPolicys = sysRestserviceServerMain.getFdPolicy();
        if (ArrayUtil.isEmpty((List)webPolicys)) {
            return "";
        }
        final SysRestserviceServerPolicy webPolicy = webPolicys.get(0);
        final String sign = SignUtil.getHMAC(String.valueOf(signStr) + ":" + webPolicy.getFdLoginId(), StringUtil.isNotNull(webPolicy.getFdPassword()) ? webPolicy.getFdPassword() : webPolicy.getFdId());
        return sign;
    }
}
